/////////////////////////////////////////////////////////////////////////////
//
//  GEM Form
//
//  A GEMform is an object that may interact with the user through a GEM
//  form (or dialog).
//
//  As a fundamental enhancement, a GEMform, unlike a standard GEM form
//  may have "call backs" associated with any of its element objects.
//  A GEMform does not actually make use of these call backs, but derived
//  classes may.
//
//  This file is Copyright 1992 by Warwick W. Allison,
//  and is freely distributable providing no charge is made.
//
/////////////////////////////////////////////////////////////////////////////

#ifndef GEMF_h
#define GEMF_h

#include "gemo.h"
#include "gemfeedb.h"
#include <bool.h>
#include <gemfast.h>

class GEMrealobject;

class GEMform
{
public:
	GEMform(int RSCindex);
	virtual ~GEMform();

	int Do(); // Centred
	int Do(int x, int y);

	bool Zooms(bool b);

	virtual void RedrawObject(int RSCindex);
	virtual void RedrawObject(int RSCindex,int Cx,int Cy,int Cw,int Ch); // Clipped
	void CallBack(class GEMobject*);

private:
	friend class GEMobject;
	bool ZoomOn;
	GEMobject* *CBO;
	int CBOs=0;
	int MaxCBOs;

protected:
	GEMrealobject *Obj;
	GEMobject* Caller(int RSCindex);
	int myindex;
	virtual ClickResult ProcessClick(int item, int x, int y)
		{ return EndInteraction; }
};
inline	bool GEMform::Zooms(bool b)	{ bool t=b; ZoomOn=b; return t; }

#endif
